package com.yuandian.dataflow.controller;

import java.io.Serializable;

import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.rpc.RpcContext;
import com.alipay.sofa.jraft.rpc.RpcProcessor;
import com.yuandian.dataflow.statemachine_old.StateFactory;
import com.yuandian.dataflow.statemachine_old.annotations.WorkerRegister;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;


/**
 *  例子 强制转换leader
 */
@Slf4j
@WorkerRegister
public class TransferLeaderProcessor implements RpcProcessor<TransferLeaderProcessor.LeaderRequest> {
    
    @Setter
    @Getter
    public static class LeaderRequest implements Serializable {
         PeerId peer;
    }
    
    @Override
    public void handleRequest(RpcContext rpcCtx, LeaderRequest request) {
        Status status = StateFactory.getCluster().getRaftNode().transferLeadershipTo(request.peer);
        rpcCtx.sendResponse(status);
        log.debug("[TransferLeader] {} change leader to {}", status, request.peer);
    }

    @Override
    public String interest() {
        return LeaderRequest.class.getName();
    }
    
}
